#!/opt/anaconda1anaconda2anaconda3/bin/Rscript

tiff(filename="multiplotAll.tif", width = 800, height = 800, units = "px", pointsize = 26, compression="lzw")
tab=as.matrix(read.table("MatriceNbSeqAliLengthByAli.csv"))
y=as.numeric(tab[,2])
x=as.numeric(tab[,3])
yhist<-hist(y, breaks=seq(0,16400,200), plot=FALSE)
xhist<-hist(x, breaks=seq(4,50,1), plot=FALSE)
top <- max(c(xhist$counts, yhist$counts))
xrange<- c(4,50)
yrange<- c(0,17000)
nf <- layout(matrix(c(2,0,1,3),2,2,byrow=TRUE), c(3,1), c(1,3), TRUE)
par(mar=c(4,4,1,1))
plot(x, y, xlab="Sequence number", ylab="Alignment length", col=rgb(114, 46, 165, maxColorValue = 255))
par(mar=c(0,4,1,1))
barplot(xhist$counts, axes=TRUE, ylim=c(0, 800), space=0,col="light green") 
par(mar=c(4,0,1,1))
#title(main = "Alignment length VS sequence number",outer=TRUE, line = -1)
#title(main=paste("B) Alignment length VS sequence number","\n",sep=""),cex.main=1,outer=TRUE, line = -3)
#title(main=paste("\n","of UP1 clusters",sep=""),cex.main=1,outer=TRUE, line = -3)
title(main="A) UPall clusters",cex.main=1,outer=TRUE, line = -3)
barplot(yhist$counts, axes=TRUE, ylim=c(0, 82), xlim=c(0, 400), space=0, horiz=TRUE,col="light blue")
dev.off()

